#include "stdafx.h"

#include "common.h"

namespace cmmn {

	using namespace System;

	int n;

	double * comp, * est;

	const double maxStV = 2000.0;
	double maxEstV;

	const int nPoints = 100;

	double param_a, param_b, param_c;

	double mean_a, mean_b, mean_c, mean_sgm, map_a, map_b, map_c, map_s;

	int ck_a, ck_b, ck_c, ck_s;

	double varErr;

	double sqr( double v ){
			return v * v;
	}


	double scale_sgm( double acpt_r ){
		double v = 1.0;
	
		if (acpt_r > 0.5){
			v = 1.0 + 9.0 * (acpt_r - 0.5) / 0.5;
		} else if (acpt_r < 0.3){
			v = 1.0 / (1.0 + 9.0 * (0.3 - acpt_r) / 0.3);
		}

		return v;
	}


	double psy0( double phi, double a, double b){
		return  a * Math::Pow( phi, b );
	}


	double psy1( double phi, double a, double b, double c){
		return  a * Math::Pow( phi - c, b );
	}


	//
	//								Quick Sort
	//
	//      S. Kawai (1988).  Methods of programming (in Japanese). Tokyo: Iwanami-shoten.
	//		S. Ishihata (1989). Algorithms and Data Structure (in Japanese). Tokyo:Iwanami-shoten
	//
	void qSort( double * d, int Lb, int Ub ){
		if (Lb < Ub){
			int p = (Lb + Ub) / 2;
			double c = d[p];
			int i = Lb;
			int j = Ub;
			do {
				while (d[i] < c) i++;
				while (c < d[j]) j--;
				if (i <= j){
					double v = d[i];
					d[i] = d[j];
					d[j] = v;
					i++;
					j--;
				}
			} while (i <= j);
			qSort(d, Lb, j);
			qSort(d, i, Ub);
		}
		return;
	}


	double calc_QR( double * d, int N ){
		qSort( d, 0, N-1 );
		return 0.5 * (d[3*N/4] - d[N/4]);
	}

	double kernelF( double x, double sd ){
		return Math::Exp(-0.5 * sqr(x/sd));
	}


	double est_distri( double x, double * d, int N, double sd ){
		double v = 0.0;
		for (int i = 0; i < N; i++)
			v += kernelF( x - d[i], sd );
		return v / (double(N) * Math::Sqrt(2.0 * Math::PI) * sd);
	}

	void calc_CI( double * d, int NSimu, double & CIL, double & Med, double & CIR ){
		Med = d[NSimu/2];
		double CIW = d[NSimu-1] - d[0];
		int posL, posR;
		for (int i = 0; i < int(NSimu*0.05); i++){
			if ((d[int(0.95*NSimu) + i] - d[i]) < CIW){
				CIW = d[int(0.95*NSimu) + i] - d[i];
				posR = int(0.95*NSimu) + i;
				posL = i;
			}
		}
		CIL = d[posL];
		CIR = d[posR];
		return;
	}



}
